package com.zd.chemical.domain.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.zd.chemical.domain.HxpClassifyConfig;
import com.zd.chemical.domain.HxpUserecord;
import com.zd.common.core.annotation.Excel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 库存管理对象 hxp_stock
 *
 * @author cyl
 * @date 2022-07-21
 */
@ApiModel("库存列表管理")
public class HxpStockVO {
    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @ApiModelProperty(value = "${comment}")
    private Long id;
    /**
     * 化学品机柜关联表id
     */
    @ApiModelProperty(required = true, value = "化学品机柜关联表id")
    private Long joinId;
    /**
     * 化学品编号
     */
    @ApiModelProperty(required = true, value = "化学品编号")
    private String chemicalNum;
    /**
     * 化学品名字
     */
    @ApiModelProperty(required = true, value = "化学品名字")
    private String chemicalName;
    /**
     * 机柜编号
     */
    @ApiModelProperty(required = true, value = "机柜编号")
    private String cabinetNum;
    /**
     * 机柜名称
     */
    @ApiModelProperty(required = true, value = "机柜名称")
    private String cabinetName;
    /**
     * 化学品分类
     */
    @ApiModelProperty(required = true, value = "化学品分类ID")
    private Long chemicalClassify;

    @ApiModelProperty(required = true, value = "化学品分类名称")
    private String classifyName;

    @ApiModelProperty(required = true, value = "化学品属性名称")
    private String classifyAttribute;

    /**
     * 库存状态（1 入库，2 用结出库，3 作废出库）
     */
    @ApiModelProperty(required = true, value = "库存状态")
    private Integer status;
    /**
     * 化学品形态（固体，体液）
     */
    @ApiModelProperty(required = true, value = "化学品形态")
    private String chemicalShape;
    /**
     * 标签类型
     */
    @ApiModelProperty(required = true, value = "标签类型")
    private Integer labelType;
    @ApiModelProperty(value = "是否打印二维码标签（1是，0否）")
    private Integer printCode;
    /**
     * 入库方式（1 称重，2 录入）
     */
    @ApiModelProperty(required = true, value = "入库方式（1 称重，2 录入）")
    private Integer joinType;
    /**
     * 入库人ID
     */
    @ApiModelProperty(value = "入库人ID")
    private Long joinUserId;
    /**
     * 入库时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "入库时间")
    private Date joinTime;
    /**
     * 过期时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(required = true, value = "过期时间")
    private Date expirationTime;
    /**
     * 计量方式（1是重量，2是体积，3是个数）
     */
    @ApiModelProperty(required = true, value = "计量方式")
    private Integer measuringMethod;
    /**
     * 单位（mg,g,kg,t）
     */
    @ApiModelProperty(value = "单位")
    private String chemicalUnit;
    /**
     * 验证方式（1是单人验证，2是双人双卡）
     */
    @ApiModelProperty(required = true, value = "验证方式（1是单人验证，2是双人双卡）")
    private Integer verification;
    /**
     * 别名
     */
    @ApiModelProperty(value = "别名")
    private String anotherName;
    /**
     * cas号
     */
    @ApiModelProperty(value = "cas号")
    private String casNum;
    /**
     * 生产厂家
     */
    @ApiModelProperty(value = "生产厂家")
    private String factory;
    /**
     * 纯度
     */
    @ApiModelProperty(value = "纯度")
    private String purity;

    @ApiModelProperty(value = "化学品规格")
    private BigDecimal chemicalAmount;
    /**
     * 化学品规格单位
     */
    @ApiModelProperty(value = "化学品规格单位")
    private String chemicalAmountUnit;
    /**
     * 入库第一验证人
     */
    @ApiModelProperty(value = "入库第一验证人")
    private Long joinOneUser;
    /**
     * 入库第二验证人
     */
    @ApiModelProperty(value = "入库第二验证人")
    private Long joinTwoUser;
    /**
     * 标签编号（二维码编号）
     */
    @ApiModelProperty(value = "标签编号")
    private String tagCode;
    /**
     * RFID编号（标签类型是1 时，必须有）
     */
    @ApiModelProperty(value = "RFID编号（标签类型是1 时，不能为空！）")
    private String rfidCode;
    /**
     * 入库重量
     */
    @ApiModelProperty(value = "入库重量")
    private BigDecimal usages;
    /**
     * 出库人ID
     */
    @ApiModelProperty(value = "出库人ID")
    private Long outUserId;
    /**
     * 出库时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty(value = "出库时间")
    private Date outTime;
    /**
     * 剩余库存量（出库时计算存储）
     * 领用归还对库存进行实时操作
     */
    @ApiModelProperty(value = "剩余库存量")
    private BigDecimal outUsages;

    @ApiModelProperty(value = "库存净重量")
    private BigDecimal suttle;
    /**
     * 实验室id
     */
    @ApiModelProperty(required = true, value = "实验室id")
    private Long subId;

    @ApiModelProperty(required = true, value = "实验室名称")
    private String subName;

    @ApiModelProperty(required = true, value = "过期类型：1是快过期，2是已过期")
    private Integer expireStatus;

    /**
     * 出库第一验证人
     */
    @ApiModelProperty(value = "出库第一验证人")
    private Long outOneUser;
    /**
     * 出库第二验证人
     */
    @ApiModelProperty(value = "出库第二验证人")
    private Long outTwoUser;

    @ApiModelProperty(value = "MSDS-ID")
    private Long hazardId;

    @ApiModelProperty(value = "当前领用信息")
    private HxpUserecord hxpUserecord;

    @ApiModelProperty(value = "化学品操作是否需要双人验证")
    private HxpClassifyConfig classifyConfig;

    private String safeUserId;

    @ApiModelProperty(value = "负责人")
    private String safeUserName;

    @ApiModelProperty(value = "容器重量")
    private BigDecimal tare;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getJoinId() {
        return joinId;
    }

    public void setJoinId(Long joinId) {
        this.joinId = joinId;
    }

    public String getChemicalNum() {
        return chemicalNum;
    }

    public void setChemicalNum(String chemicalNum) {
        this.chemicalNum = chemicalNum;
    }

    public String getChemicalName() {
        return chemicalName;
    }

    public void setChemicalName(String chemicalName) {
        this.chemicalName = chemicalName;
    }

    public String getCabinetNum() {
        return cabinetNum;
    }

    public void setCabinetNum(String cabinetNum) {
        this.cabinetNum = cabinetNum;
    }

    public String getCabinetName() {
        return cabinetName;
    }

    public void setCabinetName(String cabinetName) {
        this.cabinetName = cabinetName;
    }

    public Long getChemicalClassify() {
        return chemicalClassify;
    }

    public void setChemicalClassify(Long chemicalClassify) {
        this.chemicalClassify = chemicalClassify;
    }

    public String getClassifyName() {
        return classifyName;
    }

    public void setClassifyName(String classifyName) {
        this.classifyName = classifyName;
    }

    public String getClassifyAttribute() {
        return classifyAttribute;
    }

    public void setClassifyAttribute(String classifyAttribute) {
        this.classifyAttribute = classifyAttribute;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getChemicalShape() {
        return chemicalShape;
    }

    public void setChemicalShape(String chemicalShape) {
        this.chemicalShape = chemicalShape;
    }

    public Integer getLabelType() {
        return labelType;
    }

    public void setLabelType(Integer labelType) {
        this.labelType = labelType;
    }

    public Integer getPrintCode() {
        return printCode;
    }

    public void setPrintCode(Integer printCode) {
        this.printCode = printCode;
    }

    public Integer getJoinType() {
        return joinType;
    }

    public void setJoinType(Integer joinType) {
        this.joinType = joinType;
    }

    public Long getJoinUserId() {
        return joinUserId;
    }

    public void setJoinUserId(Long joinUserId) {
        this.joinUserId = joinUserId;
    }

    public Date getJoinTime() {
        return joinTime;
    }

    public void setJoinTime(Date joinTime) {
        this.joinTime = joinTime;
    }

    public Date getExpirationTime() {
        return expirationTime;
    }

    public void setExpirationTime(Date expirationTime) {
        this.expirationTime = expirationTime;
    }

    public Integer getMeasuringMethod() {
        return measuringMethod;
    }

    public void setMeasuringMethod(Integer measuringMethod) {
        this.measuringMethod = measuringMethod;
    }

    public String getChemicalUnit() {
        return chemicalUnit;
    }

    public void setChemicalUnit(String chemicalUnit) {
        this.chemicalUnit = chemicalUnit;
    }

    public Integer getVerification() {
        return verification;
    }

    public void setVerification(Integer verification) {
        this.verification = verification;
    }

    public String getAnotherName() {
        return anotherName;
    }

    public void setAnotherName(String anotherName) {
        this.anotherName = anotherName;
    }

    public String getCasNum() {
        return casNum;
    }

    public void setCasNum(String casNum) {
        this.casNum = casNum;
    }

    public String getFactory() {
        return factory;
    }

    public void setFactory(String factory) {
        this.factory = factory;
    }

    public String getPurity() {
        return purity;
    }

    public void setPurity(String purity) {
        this.purity = purity;
    }

    public BigDecimal getChemicalAmount() {
        return chemicalAmount;
    }

    public void setChemicalAmount(BigDecimal chemicalAmount) {
        this.chemicalAmount = chemicalAmount;
    }

    public String getChemicalAmountUnit() {
        return chemicalAmountUnit;
    }

    public void setChemicalAmountUnit(String chemicalAmountUnit) {
        this.chemicalAmountUnit = chemicalAmountUnit;
    }

    public Long getJoinOneUser() {
        return joinOneUser;
    }

    public void setJoinOneUser(Long joinOneUser) {
        this.joinOneUser = joinOneUser;
    }

    public Long getJoinTwoUser() {
        return joinTwoUser;
    }

    public void setJoinTwoUser(Long joinTwoUser) {
        this.joinTwoUser = joinTwoUser;
    }

    public String getTagCode() {
        return tagCode;
    }

    public void setTagCode(String tagCode) {
        this.tagCode = tagCode;
    }

    public String getRfidCode() {
        return rfidCode;
    }

    public void setRfidCode(String rfidCode) {
        this.rfidCode = rfidCode;
    }

    public BigDecimal getUsages() {
        return usages;
    }

    public void setUsages(BigDecimal usages) {
        this.usages = usages;
    }

    public Long getOutUserId() {
        return outUserId;
    }

    public void setOutUserId(Long outUserId) {
        this.outUserId = outUserId;
    }

    public Date getOutTime() {
        return outTime;
    }

    public void setOutTime(Date outTime) {
        this.outTime = outTime;
    }

    public BigDecimal getOutUsages() {
        return outUsages;
    }

    public void setOutUsages(BigDecimal outUsages) {
        this.outUsages = outUsages;
    }

    public BigDecimal getSuttle() {
        return suttle;
    }

    public void setSuttle(BigDecimal suttle) {
        this.suttle = suttle;
    }

    public Long getSubId() {
        return subId;
    }

    public void setSubId(Long subId) {
        this.subId = subId;
    }

    public String getSubName() {
        return subName;
    }

    public void setSubName(String subName) {
        this.subName = subName;
    }

    public Integer getExpireStatus() {
        return expireStatus;
    }

    public void setExpireStatus(Integer expireStatus) {
        this.expireStatus = expireStatus;
    }

    public Long getOutOneUser() {
        return outOneUser;
    }

    public void setOutOneUser(Long outOneUser) {
        this.outOneUser = outOneUser;
    }

    public Long getOutTwoUser() {
        return outTwoUser;
    }

    public void setOutTwoUser(Long outTwoUser) {
        this.outTwoUser = outTwoUser;
    }

    public Long getHazardId() {
        return hazardId;
    }

    public void setHazardId(Long hazardId) {
        this.hazardId = hazardId;
    }

    public HxpUserecord getHxpUserecord() {
        return hxpUserecord;
    }

    public void setHxpUserecord(HxpUserecord hxpUserecord) {
        this.hxpUserecord = hxpUserecord;
    }

    public HxpClassifyConfig getClassifyConfig() {
        return classifyConfig;
    }

    public void setClassifyConfig(HxpClassifyConfig classifyConfig) {
        this.classifyConfig = classifyConfig;
    }

    public String getSafeUserId() {
        return safeUserId;
    }

    public void setSafeUserId(String safeUserId) {
        this.safeUserId = safeUserId;
    }

    public String getSafeUserName() {
        return safeUserName;
    }

    public void setSafeUserName(String safeUserName) {
        this.safeUserName = safeUserName;
    }

    public BigDecimal getTare() {
        return tare;
    }

    public void setTare(BigDecimal tare) {
        this.tare = tare;
    }
}
